summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJohns <johns98@gmx.net>2013-01-29 17:04:50 +0100
committerJohns <johns98@gmx.net>2013-01-29 17:04:50 +0100
commitb48e0d06387f79a912e3676fce23217e664e63da (patch)
tree723692df8d1916796c366a769ffb255de2c4c69f
parent2c27d83b9ef931b8da2d80d01c0b3e5ed4b17977 (diff)
downloadvdr-plugin-softhddevice-b48e0d06387f79a912e3676fce23217e664e63da.tar.gz
vdr-plugin-softhddevice-b48e0d06387f79a912e3676fce23217e664e63da.tar.bz2
Support VDR 1.7.36 new build system.
-rw-r--r--ChangeLog3
-rw-r--r--Makefile196
-rw-r--r--Makefile-pre1.7.36187
-rw-r--r--vdr-softhddevice-9999-pre1.7.36.ebuild74
-rw-r--r--vdr-softhddevice-9999.ebuild97
-rw-r--r--video.c4
6 files changed, 421 insertions, 140 deletions
diff --git a/ChangeLog b/ChangeLog
index 5209741..20f0582 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,6 +1,9 @@
User johns
Date:
+ Support VDR 1.7.36 new build system.
+ Improves VDPAU display preemption handling.
+ Add modifiers to X11 remote key names (from Sibbi).
Add compatibility with >=ffmpeg 1.1.
Adds PIP (Picture-in-Picture) support.
Split mpeg packets in receiver thread.
diff --git a/Makefile b/Makefile
index d951ebb..dac55c5 100644
--- a/Makefile
+++ b/Makefile
@@ -6,157 +6,170 @@
# The official name of this plugin.
# This name will be used in the '-P...' option of VDR to load the plugin.
# By default the main source file also carries this name.
-# IMPORTANT: the presence of this macro is important for the Make.config
-# file. So it must be defined, even if it is not used here!
-#
-PLUGIN = softhddevice
-
-### The version number of this plugin (taken from the main source file):
-VERSION = $(shell grep 'static const char \*const VERSION *=' $(PLUGIN).cpp | awk '{ print $$7 }' | sed -e 's/[";]//g')
-GIT_REV = $(shell git describe --always 2>/dev/null)
+PLUGIN = softhddevice
### Configuration (edit this for your needs)
-CONFIG := #-DDEBUG #-DOSD_DEBUG
-CONFIG += -DAV_INFO -DAV_INFO_TIME=3000 # debug a/v sync
+ # support alsa audio output module
+ALSA ?= $(shell pkg-config --exists alsa && echo 1)
+ # support OSS audio output module
+OSS ?= 1
+ # support VDPAU video output modue
+VDPAU ?= $(shell pkg-config --exists vdpau && echo 1)
+ # support VA-API video output modue
+VAAPI ?= $(shell pkg-config --exists libva && echo 1)
+ # screensaver disable/enable
+SCREENSAVER ?= 1
+ # use ffmpeg libswresample
+SWRESAMPLE ?= $(shell pkg-config --exists libswresample && echo 1)
+
+CONFIG := # -DDEBUG #-DOSD_DEBUG
+CONFIG += -DAV_INFO -DAV_INFO_TIME=3000 # info/debug a/v sync
CONFIG += -DUSE_PIP # too experimental PIP support
#CONFIG += -DHAVE_PTHREAD_NAME # supports new pthread_setname_np
#CONFIG += -DNO_TS_AUDIO # disable ts audio parser
#CONFIG += -DUSE_TS_VIDEO # build new ts video parser
- # use ffmpeg libswresample
-CONFIG += $(shell pkg-config --exists libswresample && echo "-DUSE_SWRESAMPLE")
-CONFIG += $(shell pkg-config --exists vdpau && echo "-DUSE_VDPAU")
-CONFIG += $(shell pkg-config --exists libva && echo "-DUSE_VAAPI")
-CONFIG += $(shell pkg-config --exists alsa && echo "-DUSE_ALSA")
+
+ifeq ($(ALSA),1)
+CONFIG += -DUSE_ALSA
+_CFLAGS += $(shell pkg-config --cflags alsa)
+LIBS += $(shell pkg-config --libs alsa)
+endif
+ifeq ($(OSS),1)
CONFIG += -DUSE_OSS
+endif
+ifeq ($(VDPAU),1)
+CONFIG += -DUSE_VDPAU
+_CFLAGS += $(shell pkg-config --cflags vdpau)
+LIBS += $(shell pkg-config --libs vdpau)
+endif
+ifeq ($(VAAPI),1)
+CONFIG += -DUSE_VAAPI
+_CFLAGS += $(shell pkg-config --cflags libva-x11 libva)
+LIBS += $(shell pkg-config --libs libva-x11 libva)
+endif
+ifeq ($(SCREENSAVER),1)
+CONFIG += -DUSE_SCREENSAVER
+_CFLAGS += $(shell pkg-config --cflags xcb-screensaver xcb-dpms)
+LIBS += $(shell pkg-config --libs xcb-screensaver xcb-dpms)
+endif
+ifeq ($(SWRESAMPLE),1)
+CONFIG += -DUSE_SWRESAMPLE
+_CFLAGS += $(shell pkg-config --cflags libswresample)
+LIBS += $(shell pkg-config --libs libswresample)
+endif
+
+_CFLAGS += $(shell pkg-config --cflags libavcodec x11 x11-xcb xcb xcb-icccm)
+LIBS += -lrt $(shell pkg-config --libs libavcodec x11 x11-xcb xcb xcb-icccm)
-### The C++ compiler and options:
+### The version number of this plugin (taken from the main source file):
-CC ?= gcc
-CXX ?= g++
-CFLAGS ?= -g -O2 -W -Wall -Wextra -Winit-self \
- -Wdeclaration-after-statement \
- -ftree-vectorize -msse3 -flax-vector-conversions -fPIC
-CXXFLAGS ?= -g -O2 -W -Wall -Wextra -Werror=overloaded-virtual -fPIC
+VERSION = $(shell grep 'static const char \*const VERSION *=' $(PLUGIN).cpp | awk '{ print $$7 }' | sed -e 's/[";]//g')
+GIT_REV = $(shell git describe --always 2>/dev/null)
### The directory environment:
-VDRDIR ?= ../../..
-LIBDIR ?= ../../lib
+# Use package data if installed...otherwise assume we're under the VDR source directory:
+PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
+LIBDIR = $(call PKGCFG,libdir)
+LOCDIR = $(call PKGCFG,locdir)
+PLGCFG = $(call PKGCFG,plgcfg)
+#
TMPDIR ?= /tmp
-### Make sure that necessary options are included:
+### The compiler options:
--include $(VDRDIR)/Make.global
+export CFLAGS = $(call PKGCFG,cflags)
+export CXXFLAGS = $(call PKGCFG,cxxflags)
-### Allow user defined options to overwrite defaults:
+### The version number of VDR's plugin API:
--include $(VDRDIR)/Make.config
+APIVERSION = $(call PKGCFG,apiversion)
-### The version number of VDR's plugin API (taken from VDR's "config.h"):
+### Allow user defined options to overwrite defaults:
-APIVERSION = $(shell sed -ne '/define APIVERSION/s/^.*"\(.*\)".*$$/\1/p' $(VDRDIR)/config.h)
+-include $(PLGCFG)
### The name of the distribution archive:
ARCHIVE = $(PLUGIN)-$(VERSION)
PACKAGE = vdr-$(ARCHIVE)
-### Includes, Defines and dependencies (add further entries here):
+### The name of the shared object file:
-INCLUDES += -I$(VDRDIR)/include
+SOFILE = libvdr-$(PLUGIN).so
-DEFINES += $(CONFIG) -D_GNU_SOURCE -DPLUGIN_NAME_I18N='"$(PLUGIN)"' \
+### Includes and Defines (add further entries here):
+
+INCLUDES +=
+
+DEFINES += -DPLUGIN_NAME_I18N='"$(PLUGIN)"' $(CONFIG) \
$(if $(GIT_REV), -DGIT_REV='"$(GIT_REV)"')
-_CFLAGS = $(DEFINES) $(INCLUDES) \
- $(shell pkg-config --cflags libavcodec) \
- `pkg-config --cflags x11 x11-xcb xcb xcb-xv xcb-shm xcb-dpms xcb-atom\
- xcb-screensaver xcb-randr xcb-glx xcb-icccm xcb-keysyms`\
- `pkg-config --cflags gl glu` \
- $(if $(findstring USE_SWRESAMPLE,$(CONFIG)), \
- $(shell pkg-config --cflags libswresample)) \
- $(if $(findstring USE_VAAPI,$(CONFIG)), \
- `pkg-config --cflags libva-x11 libva-glx libva`) \
- $(if $(findstring USE_ALSA,$(CONFIG)), \
- `pkg-config --cflags alsa`)
-
-#override _CFLAGS += -Werror
-override CXXFLAGS += $(_CFLAGS)
-override CFLAGS += $(_CFLAGS)
-
-LIBS += -lrt \
- $(shell pkg-config --libs libavcodec) \
- `pkg-config --libs x11 x11-xcb xcb xcb-xv xcb-shm xcb-dpms xcb-atom\
- xcb-screensaver xcb-randr xcb-glx xcb-icccm xcb-keysyms`\
- `pkg-config --libs gl glu` \
- $(if $(findstring USE_SWRESAMPLE,$(CONFIG)), \
- $(shell pkg-config --libs libswresample)) \
- $(if $(findstring USE_VDPAU,$(CONFIG)), \
- `pkg-config --libs vdpau`) \
- $(if $(findstring USE_VAAPI,$(CONFIG)), \
- `pkg-config --libs libva-x11 libva-glx libva`) \
- $(if $(findstring USE_ALSA,$(CONFIG)), \
- `pkg-config --libs alsa`)
+### Make it standard
+
+override CXXFLAGS += $(_CFLAGS) $(DEFINES) $(INCLUDES) \
+ -g -W -Wall -Wextra -Winit-self -Werror=overloaded-virtual
+override CFLAGS += $(_CFLAGS) $(DEFINES) $(INCLUDES) \
+ -g -W -Wall -Wextra -Winit-self -Wdeclaration-after-statement
### The object files (add further files here):
OBJS = $(PLUGIN).o softhddev.o video.o audio.o codec.o ringbuffer.o
+
SRCS = $(wildcard $(OBJS:.o=.c)) $(PLUGIN).cpp
### The main target:
-all: libvdr-$(PLUGIN).so i18n
-
-### Implicit rules:
-#
-#%.o: %.cpp
-# $(CXX) $(CXXFLAGS) -c $(DEFINES) $(INCLUDES) $<
+all: $(SOFILE) i18n
### Dependencies:
-MAKEDEP = $(CC) -MM -MG
+MAKEDEP = $(CXX) -MM -MG
DEPFILE = .dependencies
$(DEPFILE): Makefile
- @$(MAKEDEP) $(DEFINES) $(INCLUDES) $(SRCS) >$@
-
-$(OBJS): Makefile
+ @$(MAKEDEP) $(CXXFLAGS) $(SRCS) > $@
-include $(DEPFILE)
### Internationalization (I18N):
PODIR = po
-LOCALEDIR = $(VDRDIR)/locale
I18Npo = $(wildcard $(PODIR)/*.po)
-I18Nmsgs = $(addprefix $(LOCALEDIR)/, $(addsuffix /LC_MESSAGES/vdr-$(PLUGIN).mo, $(notdir $(foreach file, $(I18Npo), $(basename $(file))))))
+I18Nmo = $(addsuffix .mo, $(foreach file, $(I18Npo), $(basename $(file))))
+I18Nmsgs = $(addprefix $(DESTDIR)$(LOCDIR)/, $(addsuffix /LC_MESSAGES/vdr-$(PLUGIN).mo, $(notdir $(foreach file, $(I18Npo), $(basename $(file))))))
I18Npot = $(PODIR)/$(PLUGIN).pot
%.mo: %.po
msgfmt -c -o $@ $<
-$(I18Npot): $(wildcard *.cpp) $(wildcard *.c)
- xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP \
- -k_ -k_N --package-name=VDR --package-version=$(VDRVERSION) \
- --msgid-bugs-address='<see README>' -o $@ $^
+$(I18Npot): $(SRCS)
+ xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --package-name=vdr-$(PLUGIN) --package-version=$(VERSION) --msgid-bugs-address='<see README>' -o $@ `ls $^`
%.po: $(I18Npot)
- msgmerge -U --no-wrap --no-location --backup=none -q $@ $<
+ msgmerge -U --no-wrap --no-location --backup=none -q -N $@ $<
@touch $@
-$(I18Nmsgs): $(LOCALEDIR)/%/LC_MESSAGES/vdr-$(PLUGIN).mo: $(PODIR)/%.mo
- @mkdir -p $(dir $@)
- cp $< $@
+$(I18Nmsgs): $(DESTDIR)$(LOCDIR)/%/LC_MESSAGES/vdr-$(PLUGIN).mo: $(PODIR)/%.mo
+ install -D -m644 $< $@
.PHONY: i18n
-i18n: $(I18Nmsgs) $(I18Npot)
+i18n: $(I18Nmo) $(I18Npot)
+
+install-i18n: $(I18Nmsgs)
### Targets:
-libvdr-$(PLUGIN).so: $(OBJS) Makefile
- $(CXX) $(CXXFLAGS) $(LDFLAGS) -shared -fPIC $(OBJS) -o $@ $(LIBS)
- @cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
+$(OBJS): Makefile
+
+$(SOFILE): $(OBJS)
+ $(CXX) $(CXXFLAGS) $(LDFLAGS) -shared $(OBJS) $(LIBS) -o $@
+
+install-lib: $(SOFILE)
+ install -D $^ $(DESTDIR)$(LIBDIR)/$^.$(APIVERSION)
+
+install: install-lib install-i18n
dist: $(I18Npo) clean
@-rm -rf $(TMPDIR)/$(ARCHIVE)
@@ -167,11 +180,10 @@ dist: $(I18Npo) clean
@echo Distribution package created as $(PACKAGE).tgz
clean:
- @-rm -f $(OBJS) $(DEPFILE) *.so *.tgz core* *~ $(PODIR)/*.mo $(PODIR)/*.pot
+ @-rm -f $(PODIR)/*.mo $(PODIR)/*.pot
+ @-rm -f $(OBJS) $(DEPFILE) *.so *.tgz core* *~
-install: libvdr-$(PLUGIN).so
- cp --remove-destination libvdr-$(PLUGIN).so \
- /usr/lib/vdr/plugins/libvdr-$(PLUGIN).so.$(APIVERSION)
+## Private Targets:
HDRS= $(wildcard *.h)
@@ -183,5 +195,5 @@ indent:
done
video_test: video.c Makefile
- $(CC) -DVIDEO_TEST -DVERSION='"$(VERSION)"' $(CFLAGS) $(LDFLAGS) $< $(LIBS) \
- -o $@
+ $(CC) -DVIDEO_TEST -DVERSION='"$(VERSION)"' $(CFLAGS) $(LDFLAGS) $< \
+ $(LIBS) -o $@
diff --git a/Makefile-pre1.7.36 b/Makefile-pre1.7.36
new file mode 100644
index 0000000..d951ebb
--- /dev/null
+++ b/Makefile-pre1.7.36
@@ -0,0 +1,187 @@
+#
+# Makefile for a Video Disk Recorder plugin
+#
+# $Id$
+
+# The official name of this plugin.
+# This name will be used in the '-P...' option of VDR to load the plugin.
+# By default the main source file also carries this name.
+# IMPORTANT: the presence of this macro is important for the Make.config
+# file. So it must be defined, even if it is not used here!
+#
+PLUGIN = softhddevice
+
+### The version number of this plugin (taken from the main source file):
+
+VERSION = $(shell grep 'static const char \*const VERSION *=' $(PLUGIN).cpp | awk '{ print $$7 }' | sed -e 's/[";]//g')
+GIT_REV = $(shell git describe --always 2>/dev/null)
+
+### Configuration (edit this for your needs)
+
+CONFIG := #-DDEBUG #-DOSD_DEBUG
+CONFIG += -DAV_INFO -DAV_INFO_TIME=3000 # debug a/v sync
+CONFIG += -DUSE_PIP # too experimental PIP support
+#CONFIG += -DHAVE_PTHREAD_NAME # supports new pthread_setname_np
+#CONFIG += -DNO_TS_AUDIO # disable ts audio parser
+#CONFIG += -DUSE_TS_VIDEO # build new ts video parser
+ # use ffmpeg libswresample
+CONFIG += $(shell pkg-config --exists libswresample && echo "-DUSE_SWRESAMPLE")
+CONFIG += $(shell pkg-config --exists vdpau && echo "-DUSE_VDPAU")
+CONFIG += $(shell pkg-config --exists libva && echo "-DUSE_VAAPI")
+CONFIG += $(shell pkg-config --exists alsa && echo "-DUSE_ALSA")
+CONFIG += -DUSE_OSS
+
+### The C++ compiler and options:
+
+CC ?= gcc
+CXX ?= g++
+CFLAGS ?= -g -O2 -W -Wall -Wextra -Winit-self \
+ -Wdeclaration-after-statement \
+ -ftree-vectorize -msse3 -flax-vector-conversions -fPIC
+CXXFLAGS ?= -g -O2 -W -Wall -Wextra -Werror=overloaded-virtual -fPIC
+
+### The directory environment:
+
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
+
+### Make sure that necessary options are included:
+
+-include $(VDRDIR)/Make.global
+
+### Allow user defined options to overwrite defaults:
+
+-include $(VDRDIR)/Make.config
+
+### The version number of VDR's plugin API (taken from VDR's "config.h"):
+
+APIVERSION = $(shell sed -ne '/define APIVERSION/s/^.*"\(.*\)".*$$/\1/p' $(VDRDIR)/config.h)
+
+### The name of the distribution archive:
+
+ARCHIVE = $(PLUGIN)-$(VERSION)
+PACKAGE = vdr-$(ARCHIVE)
+
+### Includes, Defines and dependencies (add further entries here):
+
+INCLUDES += -I$(VDRDIR)/include
+
+DEFINES += $(CONFIG) -D_GNU_SOURCE -DPLUGIN_NAME_I18N='"$(PLUGIN)"' \
+ $(if $(GIT_REV), -DGIT_REV='"$(GIT_REV)"')
+
+_CFLAGS = $(DEFINES) $(INCLUDES) \
+ $(shell pkg-config --cflags libavcodec) \
+ `pkg-config --cflags x11 x11-xcb xcb xcb-xv xcb-shm xcb-dpms xcb-atom\
+ xcb-screensaver xcb-randr xcb-glx xcb-icccm xcb-keysyms`\
+ `pkg-config --cflags gl glu` \
+ $(if $(findstring USE_SWRESAMPLE,$(CONFIG)), \
+ $(shell pkg-config --cflags libswresample)) \
+ $(if $(findstring USE_VAAPI,$(CONFIG)), \
+ `pkg-config --cflags libva-x11 libva-glx libva`) \
+ $(if $(findstring USE_ALSA,$(CONFIG)), \
+ `pkg-config --cflags alsa`)
+
+#override _CFLAGS += -Werror
+override CXXFLAGS += $(_CFLAGS)
+override CFLAGS += $(_CFLAGS)
+
+LIBS += -lrt \
+ $(shell pkg-config --libs libavcodec) \
+ `pkg-config --libs x11 x11-xcb xcb xcb-xv xcb-shm xcb-dpms xcb-atom\
+ xcb-screensaver xcb-randr xcb-glx xcb-icccm xcb-keysyms`\
+ `pkg-config --libs gl glu` \
+ $(if $(findstring USE_SWRESAMPLE,$(CONFIG)), \
+ $(shell pkg-config --libs libswresample)) \
+ $(if $(findstring USE_VDPAU,$(CONFIG)), \
+ `pkg-config --libs vdpau`) \
+ $(if $(findstring USE_VAAPI,$(CONFIG)), \
+ `pkg-config --libs libva-x11 libva-glx libva`) \
+ $(if $(findstring USE_ALSA,$(CONFIG)), \
+ `pkg-config --libs alsa`)
+
+### The object files (add further files here):
+
+OBJS = $(PLUGIN).o softhddev.o video.o audio.o codec.o ringbuffer.o
+SRCS = $(wildcard $(OBJS:.o=.c)) $(PLUGIN).cpp
+
+### The main target:
+
+all: libvdr-$(PLUGIN).so i18n
+
+### Implicit rules:
+#
+#%.o: %.cpp
+# $(CXX) $(CXXFLAGS) -c $(DEFINES) $(INCLUDES) $<
+
+### Dependencies:
+
+MAKEDEP = $(CC) -MM -MG
+DEPFILE = .dependencies
+$(DEPFILE): Makefile
+ @$(MAKEDEP) $(DEFINES) $(INCLUDES) $(SRCS) >$@
+
+$(OBJS): Makefile
+
+-include $(DEPFILE)
+
+### Internationalization (I18N):
+
+PODIR = po
+LOCALEDIR = $(VDRDIR)/locale
+I18Npo = $(wildcard $(PODIR)/*.po)
+I18Nmsgs = $(addprefix $(LOCALEDIR)/, $(addsuffix /LC_MESSAGES/vdr-$(PLUGIN).mo, $(notdir $(foreach file, $(I18Npo), $(basename $(file))))))
+I18Npot = $(PODIR)/$(PLUGIN).pot
+
+%.mo: %.po
+ msgfmt -c -o $@ $<
+
+$(I18Npot): $(wildcard *.cpp) $(wildcard *.c)
+ xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP \
+ -k_ -k_N --package-name=VDR --package-version=$(VDRVERSION) \
+ --msgid-bugs-address='<see README>' -o $@ $^
+
+%.po: $(I18Npot)
+ msgmerge -U --no-wrap --no-location --backup=none -q $@ $<
+ @touch $@
+
+$(I18Nmsgs): $(LOCALEDIR)/%/LC_MESSAGES/vdr-$(PLUGIN).mo: $(PODIR)/%.mo
+ @mkdir -p $(dir $@)
+ cp $< $@
+
+.PHONY: i18n
+i18n: $(I18Nmsgs) $(I18Npot)
+
+### Targets:
+
+libvdr-$(PLUGIN).so: $(OBJS) Makefile
+ $(CXX) $(CXXFLAGS) $(LDFLAGS) -shared -fPIC $(OBJS) -o $@ $(LIBS)
+ @cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
+
+dist: $(I18Npo) clean
+ @-rm -rf $(TMPDIR)/$(ARCHIVE)
+ @mkdir $(TMPDIR)/$(ARCHIVE)
+ @cp -a * $(TMPDIR)/$(ARCHIVE)
+ @tar czf $(PACKAGE).tgz -C $(TMPDIR) $(ARCHIVE)
+ @-rm -rf $(TMPDIR)/$(ARCHIVE)
+ @echo Distribution package created as $(PACKAGE).tgz
+
+clean:
+ @-rm -f $(OBJS) $(DEPFILE) *.so *.tgz core* *~ $(PODIR)/*.mo $(PODIR)/*.pot
+
+install: libvdr-$(PLUGIN).so
+ cp --remove-destination libvdr-$(PLUGIN).so \
+ /usr/lib/vdr/plugins/libvdr-$(PLUGIN).so.$(APIVERSION)
+
+HDRS= $(wildcard *.h)
+
+indent:
+ for i in $(SRCS) $(HDRS); do \
+ indent $$i; \
+ unexpand -a $$i | sed -e s/constconst/const/ > $$i.up; \
+ mv $$i.up $$i; \
+ done
+
+video_test: video.c Makefile
+ $(CC) -DVIDEO_TEST -DVERSION='"$(VERSION)"' $(CFLAGS) $(LDFLAGS) $< $(LIBS) \
+ -o $@
diff --git a/vdr-softhddevice-9999-pre1.7.36.ebuild b/vdr-softhddevice-9999-pre1.7.36.ebuild
new file mode 100644
index 0000000..b5f708f
--- /dev/null
+++ b/vdr-softhddevice-9999-pre1.7.36.ebuild
@@ -0,0 +1,74 @@
+# Copyright 1999-2012 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: $
+
+EAPI="4"
+
+inherit eutils vdr-plugin-2
+
+if [[ ${PV} == "9999" ]] ; then
+ inherit git-2
+ EGIT_REPO_URI="git://projects.vdr-developer.org/vdr-plugin-softhddevice.git"
+else
+ SRC_URI="http://projects.vdr-developer.org/attachments/download/838/${P}.tgz"
+fi
+
+
+DESCRIPTION="A software and GPU emulated HD output device plugin for VDR."
+HOMEPAGE="http://projects.vdr-developer.org/projects/show/plg-softhddevice"
+SRC_URI=""
+
+LICENSE="AGPL-3"
+SLOT="0"
+KEYWORDS="~x86 ~amd64"
+IUSE="vaapi vdpau alsa oss yaepg opengl debug"
+
+DEPEND=">=x11-libs/libxcb-1.8
+ x11-libs/xcb-util
+ x11-libs/xcb-util-wm
+ x11-libs/xcb-util-keysyms
+ x11-libs/xcb-util-renderutil
+ x11-libs/libX11
+ opengl? ( virtual/opengl )
+ >=virtual/ffmpeg-0.7
+ sys-devel/gettext
+ sys-devel/make
+ dev-util/pkgconfig
+ yaepg? ( >=media-video/vdr-1.7.23[yaepg] )
+ !yaepg? ( >=media-video/vdr-1.7.23 )
+ vdpau? ( x11-libs/libvdpau virtual/ffmpeg[vdpau] )
+ vaapi? ( x11-libs/libva virtual/ffmpeg[vaapi] )
+ alsa? ( media-libs/alsa-lib )
+ oss? ( sys-kernel/linux-headers )
+"
+
+src_prepare() {
+ vdr-plugin-2_src_prepare
+}
+
+src_compile() {
+ local myconf
+
+ myconf="-DHAVE_PTHREAD_NAME -DAV_INFO -DAV_INFO_TIME=15000"
+ use vdpau && myconf="${myconf} -DUSE_VDPAU"
+ use vaapi && myconf="${myconf} -DUSE_VAAPI"
+ use alsa && myconf="${myconf} -DUSE_ALSA"
+ use oss && myconf="${myconf} -DUSE_OSS"
+ use debug && myconf="${myconf} -DDEBUG"
+
+ #vdr-plugin-2_src_compile
+ cd "${S}"
+
+ BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
+
+ emake ${BUILD_PARAMS} CONFIG="${myconf}" \
+ ${BUILD_TARGETS} \
+ LOCALEDIR="${TMP_LOCALE_DIR}" \
+ LIBDIR="${S}" \
+ TMPDIR="${T}" \
+ || die "emake failed"
+}
+
+src_install() {
+ vdr-plugin-2_src_install
+}
diff --git a/vdr-softhddevice-9999.ebuild b/vdr-softhddevice-9999.ebuild
index b5f708f..a849987 100644
--- a/vdr-softhddevice-9999.ebuild
+++ b/vdr-softhddevice-9999.ebuild
@@ -4,71 +4,76 @@
EAPI="4"
-inherit eutils vdr-plugin-2
+inherit flag-o-matic toolchain-funcs vdr-plugin-2 eutils
-if [[ ${PV} == "9999" ]] ; then
- inherit git-2
- EGIT_REPO_URI="git://projects.vdr-developer.org/vdr-plugin-softhddevice.git"
+if [ "${PV}" = "9999" ]; then
+ inherit git-2
+ EGIT_REPO_URI="git://projects.vdr-developer.org/vdr-plugin-softhddevice.git"
+ KEYWORDS=""
else
- SRC_URI="http://projects.vdr-developer.org/attachments/download/838/${P}.tgz"
+ SRC_URI="mirror://vdr-developerorg/889/${P}.tgz"
+ KEYWORDS="~amd64 ~x86"
fi
-
-DESCRIPTION="A software and GPU emulated HD output device plugin for VDR."
+DESCRIPTION="Software and GPU emulated HD output device plugin for VDR"
HOMEPAGE="http://projects.vdr-developer.org/projects/show/plg-softhddevice"
-SRC_URI=""
LICENSE="AGPL-3"
SLOT="0"
-KEYWORDS="~x86 ~amd64"
-IUSE="vaapi vdpau alsa oss yaepg opengl debug"
-
-DEPEND=">=x11-libs/libxcb-1.8
- x11-libs/xcb-util
- x11-libs/xcb-util-wm
- x11-libs/xcb-util-keysyms
- x11-libs/xcb-util-renderutil
- x11-libs/libX11
- opengl? ( virtual/opengl )
- >=virtual/ffmpeg-0.7
- sys-devel/gettext
- sys-devel/make
- dev-util/pkgconfig
- yaepg? ( >=media-video/vdr-1.7.23[yaepg] )
- !yaepg? ( >=media-video/vdr-1.7.23 )
- vdpau? ( x11-libs/libvdpau virtual/ffmpeg[vdpau] )
- vaapi? ( x11-libs/libva virtual/ffmpeg[vaapi] )
- alsa? ( media-libs/alsa-lib )
- oss? ( sys-kernel/linux-headers )
-"
+IUSE="alsa oss vaapi vdpau yaepg xscreensaver debug"
+
+RDEPEND=">=media-video/vdr-1.7
+ >=virtual/ffmpeg-0.7[vdpau?,vaapi?]
+ x11-libs/libX11
+ >=x11-libs/libxcb-1.8
+ x11-libs/xcb-util-wm
+ alsa? ( media-libs/alsa-lib )
+ vdpau? ( x11-libs/libvdpau )
+ vaapi? ( x11-libs/libva )
+ alsa? ( media-libs/alsa-lib )
+ yaepg? ( >=media-video/vdr-1.7[yaepg] )"
+DEPEND="${RDEPEND}
+ x11-libs/xcb-util
+ sys-devel/gettext
+ virtual/pkgconfig
+ oss? ( sys-kernel/linux-headers )"
src_prepare() {
- vdr-plugin-2_src_prepare
+ vdr-plugin-2_src_prepare
}
src_compile() {
- local myconf
+ local myconf
+
+ myconf+=" ALSA=$(usex alsa 1 0)"
+ myconf+=" OSS=$(usex oss 1 0)"
+ myconf+=" VDPAU=$(usex vdpau 1 0)"
+ myconf+=" VAAPI=$(usex vaapi 1 0)"
+ myconf+=" SCREENSAVER=$(usex xscreensaver 1 0)"
+ # FIXME: need to know, if libav or ffmpeg is used for virtual/ffmpeg
+ myconf+=" SWRESAMPLE=1"
- myconf="-DHAVE_PTHREAD_NAME -DAV_INFO -DAV_INFO_TIME=15000"
- use vdpau && myconf="${myconf} -DUSE_VDPAU"
- use vaapi && myconf="${myconf} -DUSE_VAAPI"
- use alsa && myconf="${myconf} -DUSE_ALSA"
- use oss && myconf="${myconf} -DUSE_OSS"
- use debug && myconf="${myconf} -DDEBUG"
+ append-cflags -DHAVE_PTHREAD_NAME
+ append-cxxflags -DHAVE_PTHREAD_NAME
+ tc-export CC CXX
- #vdr-plugin-2_src_compile
- cd "${S}"
+ #emake all LIBDIR="." $myconf || die
- BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
+ #vdr-plugin-2_src_compile
+ cd "${S}"
- emake ${BUILD_PARAMS} CONFIG="${myconf}" \
- ${BUILD_TARGETS} \
- LOCALEDIR="${TMP_LOCALE_DIR}" \
- LIBDIR="${S}" \
- TMPDIR="${T}" \
+ BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
+
+ emake ${BUILD_PARAMS} ${myconf} \
+ ${BUILD_TARGETS} \
+ LOCALEDIR="${TMP_LOCALE_DIR}" \
+ LIBDIR="${S}" \
+ TMPDIR="${T}" \
|| die "emake failed"
}
src_install() {
- vdr-plugin-2_src_install
+ vdr-plugin-2_src_install
+
+ dodoc ChangeLog
}
diff --git a/video.c b/video.c
index d5573f7..5370807 100644
--- a/video.c
+++ b/video.c
@@ -39,7 +39,7 @@
///
#define USE_XLIB_XCB ///< use xlib/xcb backend
-#define USE_SCREENSAVER ///< support disable screensaver
+#define noUSE_SCREENSAVER ///< support disable screensaver
#define USE_AUTOCROP ///< compile auto-crop support
#define USE_GRAB ///< experimental grab code
#define noUSE_GLX ///< outdated GLX code
@@ -103,7 +103,7 @@
//#include <xcb/xcb_image.h>
//#include <xcb/xcb_event.h>
-#include <xcb/xcb_atom.h>
+//#include <xcb/xcb_atom.h>
#include <xcb/xcb_icccm.h>
#ifdef XCB_ICCCM_NUM_WM_SIZE_HINTS_ELEMENTS
#include <xcb/xcb_ewmh.h>